#include "defines.h"

#include <ctype.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>

#include <avr/interrupt.h>

#include <util/delay.h>

#include "uart.h"


FILE uart_str = FDEV_SETUP_STREAM(uart_putchar, uart_getchar, _FDEV_SETUP_RW);

int main(void)
{
  uart_init();
  stdout = stdin = &uart_str;
  printf("Linetracer ready 1!\n");

  DDRC=0x20;
  DDRD=0x30;
  DDRB=0x03;

  _delay_ms(5000);

  //PWM, Phase and frequency correct, TOP=ICR1
  TCCR1A=0xA0; //clear on up-counting, set on down-counting
  TCCR1B=0x11; //Clock prescaler 1/1
  ICR1=740;  //Set 5000Hz frequency	
  PORTB=0x00;
  OCR1A=0;
  OCR1B=0;
  int count=0;
  while(1==1){
    DDRA=0xFF;
	PORTA=0xFF;
	DDRC|=0xC0;
	PORTC|=0xC0;
	_delay_us(1000);
	DDRA=0x00;
	PORTA=0x00;
	DDRC&=~0xC0;
	PORTC&=~0xC0;
	PORTC|=0x20;
	_delay_us(5000);
	int x=PINA;
	int y=PINC>>6;
	if(y==1){ y=2; }else if (y==2){y=1;};
	x=x+(y<<8);
	int pos1=-1;
	int pos2=10;

	for(int i=0; i<10; i++){
	   int j=x&0x01;
	   if(j==1 && pos1==-1){ pos1=i; };
	   if(j==1){ pos2=i; };
	   //printf("%d",j);
	   x=x>>1;
	};
	//printf("\n");

	if(pos2-pos1<3){
	  count=0;
	  int pos=(pos2+pos1)/2;
	  if(pos>5){
	    OCR1A=300;
  		OCR1B=150;
		if(pos>6){
		    OCR1A=250;
  			OCR1B=100;
		};
		if(pos>7){
		    PORTB=0x02;
			OCR1A=250;
  			OCR1B=0;
		};
		
		if(pos>8){
		    PORTB=0x02;
			OCR1A=250;
  			OCR1B=150;
		};
		
	  }else if(pos<4){
	    OCR1A=150;
  		OCR1B=300;
		if(pos<3){
		    OCR1A=100;
  			OCR1B=250;
		};
		if(pos<2){
		    PORTB=0x01;
			OCR1A=0;
  			OCR1B=250;
		};
		
		if(pos<1){
		    PORTB=0x01;
			OCR1A=150;
  			OCR1B=250;
		};
		
	  }else{
	    PORTB=0x00;
	  	OCR1A=350;
  		OCR1B=350;
	  };
    }else{
	  count++;
	  if(count>80){
	  	OCR1A=0;
      	OCR1B=0;
	  };
	};
		
  	_delay_us(1000);

  };
}
